package dk.sundhedsdatastyrelsen.cbs.datacache.invalidation.impl;


import dk.sundhedsdatastyrelsen.cbs.dao.LabResultRecord;
import dk.sundhedsdatastyrelsen.cbs.dao.impl.jdbc.LabResultRecordImpl;
import dk.sundhedsdatastyrelsen.cbs.datacache.Writer;
import dk.sundhedsdatastyrelsen.cbs.datacache.invalidation.CacheInvalidationRecord;
import dk.sundhedsdatastyrelsen.cbs.datacache.invalidation.RecordInvalidator;
import dk.sundhedsdatastyrelsen.cbs.dto.lab.LabResult;
import dk.vaccinationsregister.schemas._2021._04._01.Covid19VaccinationCardType;

public class LabResultRecordInvalidator implements RecordInvalidator {

    private final Writer<LabResultRecord<LabResult, Covid19VaccinationCardType>> writer;

    public LabResultRecordInvalidator(Writer<LabResultRecord<LabResult, Covid19VaccinationCardType>> writer) {
        this.writer = writer;
    }

    @Override
    public boolean invalidate(CacheInvalidationRecord record) {
        LabResultRecordImpl<LabResult, Covid19VaccinationCardType> labResultRecord = new LabResultRecordImpl<LabResult, Covid19VaccinationCardType>()
            .cpr(record.getCpr())
            .traceId(record.getTraceId())
            .invalidationTime(record.getInvalidationTime());

        return writer.write(labResultRecord);
    }
}
