package dk.sundhedsdatastyrelsen.cbs.datacache.invalidation.impl;


import dk.sundhedsdatastyrelsen.cbs.dao.VaccinationRecord;
import dk.sundhedsdatastyrelsen.cbs.dao.impl.jdbc.VaccinationRecordImpl;
import dk.sundhedsdatastyrelsen.cbs.datacache.Writer;
import dk.sundhedsdatastyrelsen.cbs.datacache.invalidation.CacheInvalidationRecord;
import dk.sundhedsdatastyrelsen.cbs.datacache.invalidation.RecordInvalidator;
import dk.sundhedsdatastyrelsen.cbs.dto.vaccination.Vaccination;
import dk.vaccinationsregister.schemas._2021._04._01.Covid19VaccinationCardType;

public class VaccinationRecordInvalidator implements RecordInvalidator {

    private final Writer<VaccinationRecord<Vaccination, Covid19VaccinationCardType>> writer;

    public VaccinationRecordInvalidator(Writer<VaccinationRecord<Vaccination, Covid19VaccinationCardType>> writer) {
        this.writer = writer;
    }

    @Override
    public boolean invalidate(CacheInvalidationRecord record) {
        VaccinationRecordImpl<Vaccination, Covid19VaccinationCardType> vaccinationRecord = new VaccinationRecordImpl<Vaccination, Covid19VaccinationCardType>()
            .cpr(record.getCpr())
            .traceId(record.getTraceId())
            .invalidationTime(record.getInvalidationTime());

        return writer.write(vaccinationRecord);
    }
}
