package dk.sundhedsdatastyrelsen.cbs.datacache.invalidation;

import dk.sundhedsdatastyrelsen.cbs.dao.LabResultRecord;
import dk.sundhedsdatastyrelsen.cbs.dao.VaccinationRecord;
import dk.sundhedsdatastyrelsen.cbs.datacache.Writer;
import dk.sundhedsdatastyrelsen.cbs.dto.lab.LabResult;
import dk.sundhedsdatastyrelsen.cbs.dto.vaccination.Vaccination;
import dk.vaccinationsregister.schemas._2021._04._01.Covid19VaccinationCardType;
import org.apache.log4j.Logger;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.PropertySource;
import org.springframework.lang.NonNull;

@Configuration
@PropertySource("classpath:application-test.properties")
public class TestConfig {

    Logger log = Logger.getLogger("TestWriter");

    @Bean
    @NonNull
    public Writer<VaccinationRecord<Vaccination, Covid19VaccinationCardType>> vaccinationWriter() {
        return record -> {
            log.info("Writing VaccinationRecord " + record.traceId() + " :: " + record.invalidationTime());
            return true;
        };
    }

    @Bean
    @NonNull
    public Writer<LabResultRecord<LabResult, Covid19VaccinationCardType>> labResultWriter() {
        return record -> {
            log.info("Writing LabResultRecord " + record.traceId() + " :: " + record.invalidationTime());
            return true;
        };
    }
}
